---
title: LockManager.request()
slug: Web/API/LockManager/request
tags:
  - API
  - Experimental
  - LockManager
  - Method
  - Reference
  - Web Locks API
  - request()
---
<p>{{APIRef("Web Locks")}}{{SeeCompatTable}}</p>

<p><span class="seoSummary">The <strong><code>request()</code></strong> method of the {{domxref("LockManager")}} interface requests a {{domxref('Lock')}} object with parameters specifying its name and characteristics. The requested <code>Lock</code> is passed to a callback, while the function itself returns a {{jsxref('Promise')}} that resolves with {{jsxref('undefined')}}.</span></p>

<p>The <code>mode</code> property of the <code>options</code> parameter may be either <code>"exclusive"</code> or <code>"shared"</code>.</p>

<p>Request an <code>"exclusive"</code> lock when it should only be held by one code instance at a time. This applies to code in both tabs and workers. Use this to represent mutually exclusive access to a resource. When an <code>"exclusive"</code> lock for a given name is held, no other lock with the same name can be held.</p>

<p>Request a <code>"shared"</code> lock when multiple instances of the code can share access to a resource. When a <code>"shared"</code> lock for a given name is held, other <code>"shared"</code> locks for the same name can be granted, but no <code>"exclusive"</code> locks with that name can be held or granted.</p>

<p>This shared/exclusive lock pattern is common in database transaction architecture, for example to allow multiple simultaneous readers (each requests a <code>"shared"</code> lock) but only one writer (a single <code>"exclusive"</code> lock). This is known as the readers-writer pattern. In the <a href="/docs/Web/API/IndexedDB_API">IndexedDB API</a>, this is exposed as <code>"readonly"</code> and <code>"readwrite"</code> transactions which have the same semantics.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">LockManager.request(var promise = <var>name</var>[, <var>{options}</var>], <var>callback</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>name</dt>
 <dd>An identifier for the lock you want to request.</dd>
 <dt>options {{optional_inline}}</dt>
 <dd>An object describing characteristics of the lock you want to create. Valid values are:
 <ul>
  <li><code>mode</code> {{optional_inline}}: Either <code>"exclusive"</code> or <code>"shared"</code>. The default value is <code>"exclusive"</code>.</li>
  <li><code>ifAvailable</code> {{optional_inline}}: If <code>true</code>, the lock request will only be granted if it is not already held. If it cannot be granted, the callback will be invoked with <code>null</code> instead of a <code>Lock</code> instance. The default value is <code>false</code>.</li>
  <li><code>steal</code> {{optional_inline}}: If <code>true</code>, then any held locks with the same name will be released, and the request will be granted, preempting any queued requests for it. The default value is <code>false</code>.</li>
  <li><code>signal</code> {{optional_inline}}: An <code>AbortSignal</code> (the <code>signal</code> property of an <code>AbortController</code>); if specified and the <code>AbortController</code> is aborted, the lock request is dropped if it was not already granted.</li>
 </ul>
 </dd>
 <dt>callback</dt>
 <dd>…</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref('Promise')}} that resolves with undefined when the request is granted.</p>

<h2 id="Examples">Examples</h2>

<h3 id="General_Example">General Example</h3>

<p>The following example shows the basic use of the <code>request()</code> method with an asynchronous function as the callback. Once the callback is invoked, no other running code on this orign can hold `<code>my_resource</code>` until the callback returns.</p>

<pre class="brush: js">await navigator.locks.request('my_resource', async lock =&gt; {
  // The lock was granted.
});
</pre>

<h3 id="Mode_Example">Mode Example</h3>

<p>The following example shows how to use the <code>mode</code> option for readers and writers.</p>

<p>Notice that both functions use a lock called <code>my_resource</code>. The <code>do_read()</code> requests a lock in <code>'shared'</code> mode meaning that multiple calls may occur simultaneously across different event handlers, tabs, or workers.</p>

<pre class="brush: js">async function do_read() {
  await navigator.locks.request('my_resource', {mode: 'shared'}, async lock =&gt; {
    // Read code here.
  });
}</pre>

<p>The <code>do_write()</code> function use the same lock but in <code>'exclusive'</code> mode which will delay invocation of the <code>request()</code> call in <code>do_read()</code> until the write operation has completed. This applies across event handlers, tabs, or workers.</p>

<pre class="brush: js">function do_write() {
  await navigator.locks.request('my_resource', {mode: 'exclusive'}, async lock =&gt; {
    // Write code here.
  });
}</pre>

<h3 id="ifAvailable_Example">ifAvailable Example</h3>

<p>To grab a lock only if it isn't already being held, use the <code>ifAvailable</code> option. In this function <code>await</code> means the method will not return until the callback is complete. Since the lock is only granted if it was available, this call avoids needing to wait on the lock being released elsehwere.</p>

<pre class="brush: js">await navigator.locks.request('my_resource', {ifAvailable: true}, async lock =&gt; {
  if (!lock) {
    // The lock was not granted - get out fast.
    return;
  }

  // The lock was granted, and no other running code in this origin is holding
  // the 'my_res_lock' lock until this returns.
});
</pre>

<h3 id="signal_Example">signal Example</h3>

<p>To only wait for a lock for a short period of time, use the <code>signal</code> option.</p>

<pre class="brush: js">const controller = new AbortController();
// Wait at most 200ms.
setTimeout(() =&gt; controller.abort(), 200);

try {
  await navigator.locks.request('my_resource', {signal: controller.signal}, async lock =&gt; {
    // The lock was acquired!
  });
} catch (ex) {
  if (ex.name === 'AbortError') {
    // The request aborted before it could be granted.
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Locks','#dom-lockmanager-request','request()')}}</td>
   <td>{{Spec2('Web Locks')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.LockManager.request")}}</p>
